# =======================================================================================
# Title .........: liteDB
# Description ...: liteDB via SQL
# Requirement(s).: PowerShell 7
# Author ........: Giovanni Rossati (El Condor)
# Version........: 0.1.0
# Date...........: 19 July 2023
# =======================================================================================
function liteDB($parm,$db = $null) {
	$x = $parm -match '(\w+)(.*)'
	$parm2 = $matches[2].trim()
	if ($Matches[1] -eq "Open") {
		$dbx = [LiteDB.LiteDatabase]::new($parm2)
		return $dbx
	} elseif ($Matches[1] -eq "Close") {
		$db.dispose()
	} elseif ($Matches[1] -eq "List") {		
		$x = $parm2 -match '(\w+)\s+from\s+(\w+)'
		$reader = $db.Execute("Select @key AS " + $Matches[1] + " FROM " + $Matches[2] + " GROUP BY " + $Matches[1])
		$aList = [System.Collections.ArrayList]@()
		while ($reader.Read()){
			$x = $aList.Add($reader['Author'].RawValue)
		}
		return $aList.toArray()
	} elseif ($Matches[1] -eq "SELECT") {
		$aList = [System.Collections.ArrayList]@()		
		$reader = $db.Execute($parm)
		while ($reader.Read()){			
			$hash = @{}
			$reader.Current | % {$hash[$_.Key] = $_.Value.toString().Trim('"')}			
			$x = $aList.Add($hash)
		}
		return ,$aList.toArray()
	} elseif ($Matches[1] -eq "DELETE") {
		return $db.Execute($parm)		
	} elseif ($Matches[1] -eq "INSERT") {
		return $db.Execute($parm)
	} elseif ($Matches[1] -eq "UPDATE") {
		return $db.Execute($parm)
	}
}
Export-ModuleMember -Function LiteDB