import-module .\liteDB.psm1 -force
add-type -path "C:\Program Files\PowerShell\7\LiteDB.dll"
function fg_createWidget ($type, $text, [int]$top = -1,[int]$left = -1,$width=-1,$height=-1, $tag = "") {		# create widget
	$wdg = Invoke-Expression ("New-Object System.Windows.Forms." +$type)
	if ($left -ne -1) {$wdg.left = $left}
	if ($top -ne -1) {$wdg.top = $top}
	if ($width -ne -1) {$wdg.width = $width}
	if ($height -ne -1) {$wdg.height = $height}
	$wdg.tag = $tag
	if ($text -ne "") {
		$wdg.Text = $text
		if ($w -eq -1) {$wdg.width = $wdg.preferredWidth}
	}
	return $wdg
}
function fg_listObject($obj) {$obj.GetEnumerator() | ForEach-Object {[Console]::WriteLine($_.name+ ": "+$_.value)}}
function handleCombo() {
	$a = $list.SelectedItem
	if ($a -eq "List Authors") {
		$sql = "LIST Author FROM Quotes"
		$script:command.text = $sql
		$a = liteDB $sql $db
		$script:answer.text = $a.count
		Foreach ($i in $a) {
			[Console]::WriteLine($i)
		}
	} elseif ($a -eq "Add row") {
		$values = @{Author = "Unknown"; Where ="Where"; Quote =  '{0:yyyyMMdd_HHmmss_ffff}' -f (Get-Date)}
		$sql = "INSERT INTO Quotes VALUES " + ($values | ConvertTo-Json)
		$script:command.text = $sql
		$p = liteDB $sql $db
		$script:answer.text = $p.current.toString() + " row inserted"
	} elseif ($a -eq "Delete rows") {
		$sql = "DELETE Quotes WHERE Author = 'Unknown'"
		$script:command.text = $sql
		$p = liteDB $sql $db
		$script:answer.text = $p.current.toString() + " row(s) deleted"
	} elseif ($a -eq "Select") {
		$sql = "SELECT _id, TimeStamp, Author, Quote FROM Quotes WHERE Author LIKE '%Smith%' LIMIT 3"
		$script:command.text = $sql
		$p = liteDB $sql $db
		$script:answer.text = $p.count.toString() + " row(s) retrieved"	
		Foreach ($i in $p) {
			fg_listObject $i
		}
	} elseif ($a -eq "Modify rows") {
		$sql = "UPDATE QUotes SET TimeStamp = '" + '{0:yyyyMMdd_HHmmss_ffff}' -f (Get-Date) + "' WHERE Author LIKE '%Smith%'"
		$script:command.text = $sql
		$p = liteDB $sql $db
		$script:answer.text = $p.current.toString() + " row(s) modified"	
	}		
}
$db = liteDB "Open Quotes.db"
$frm = New-Object System.Windows.Forms.Form
$frm.Text = "Powershell -LiteDB"
$label = fg_createWidget "Label"  -text "Action" -left 10 -top 20 -width 75
$frm.controls.add($label)
$answer = fg_createWidget "Label"  -text "" -left 10 -top 55 -width 120
$command = fg_createWidget "Label"  -text "" -left 10 -top 80 -width 200 -height 250
$frm.controls.add($answer)
$frm.controls.add($command)
$list = fg_createWidget "ComboBox" "Typical" -left 100 -top 20 -width 170 -height 25
$list.DropDownStyle = 2
$listItem = @("Add row","Delete rows","List Authors","Modify rows","Select")
$list.Items.AddRange($listItem)
$list.Add_SelectedIndexChanged({handleCombo})
$frm.controls.add($list)
$frm.ShowDialog()
$db = liteDB "Close" $db